/**
 * Copyright (c) 2013, SVZ Solutions All Rights Reserved.
 * Available via BSD license, see license file included for details.
 *
 * @title:                SVZ Solutions Maps
 * @authors:           Stefan van Zanden <info@svzsolutions.nl>
 * @company:          SVZ Solutions
 * @contributers:
 * @version:          0.6.2
 * @versionDate:      2013-03-22
 * @date:             2013-03-22
 */
define("svzsolutions/generic/Debug",[],function(){dojo.declare("svzsolutions.generic.Debug",null,{constructor:function(){},log:function(e,o){if("undefined"!=typeof console)switch(o){case"error":console.error(e);break;default:console.log(e)}}})}),define("svzsolutions/generic/Geocode",[],function(){dojo.declare("svzsolutions.generic.Geocode",null,{DMS_DEG_SIGN_UTF8:"°",DMS_MIN_SIGN_UTF8:"′",DMS_SEC_SIGN_UTF8:"″",DMS_DEFAULT_FORMAT:"%deg%%deg-sign% %min%%min-sign% %sec%%sec-sign% %car-dir%",constructor:function(e,o){this._latitude=e,this._longitude=o},getLatitude:function(){return this._latitude},setLatitude:function(e){this._latitude=e},getLongitude:function(){return this._longitude},setLongitude:function(e){this._longitude=e},isValid:function(){return this.isValidLatitude()&&this.isValidLongitude()?!0:!1},isValidLatitude:function(){return isNaN(this._latitude)?!1:this._latitude>=-90&&90>=this._latitude?!0:!1},isValidLongitude:function(){return isNaN(this._longitude)?!1:this._longitude>=-180&&180>=this._longitude?!0:!1},toDMS:function(e){return""==e?!1:(dms=[],parts=(""+e).split("."),dms.degree=parts[0],dmsRemainder=60*("0."+parts[1]),dmsRemainderParts=(""+dmsRemainder).split("."),dms.minutes=dmsRemainderParts[0],dmsRemainder=60*("0."+dmsRemainderParts[1]),dms.seconds=Math.round(dmsRemainder),dms)},getLatitudeInDMS:function(e){e||(e=this.DMS_DEFAULT_FORMAT);var o="N";"-"==(""+this._latitude).substr(0,1)&&(o="S");var t=this.toDMS(this._latitude);return dms=e.replace("%deg%",t.degree),dms=dms.replace("%deg-sign%",this.DMS_DEG_SIGN_UTF8),dms=dms.replace("%min%",t.minutes),dms=dms.replace("%min-sign%",this.DMS_MIN_SIGN_UTF8),dms=dms.replace("%sec%",t.seconds),dms=dms.replace("%sec-sign%",this.DMS_SEC_SIGN_UTF8),dms=dms.replace("%car-dir%",o)},getLongitudeInDMS:function(e){e||(e=this.DMS_DEFAULT_FORMAT);var o="E";"-"==(""+this._longitude).substr(0,1)&&(o="W");var t=this.toDMS(this._longitude);return dms=e.replace("%deg%",t.degree),dms=dms.replace("%deg-sign%",this.DMS_DEG_SIGN_UTF8),dms=dms.replace("%min%",t.minutes),dms=dms.replace("%min-sign%",this.DMS_MIN_SIGN_UTF8),dms=dms.replace("%sec%",t.seconds),dms=dms.replace("%sec-sign%",this.DMS_SEC_SIGN_UTF8),dms=dms.replace("%car-dir%",o)},retrieveUserLocation:function(){navigator.geolocation&&navigator.geolocation.getCurrentPosition(dojo.hitch(this,function(e){this._latitude=e.coords.latitude,this._longitude=e.coords.longitude,this.onRetrieveUserLocationResult()}),dojo.hitch(this,function(e){console.log("Geocode: error while retrieving user location: [",e,"]"),this.onRetrieveUserLocationError(e)}))},onRetrieveUserLocationResult:function(){},onRetrieveUserLocationError:function(){},findAddress:function(){this._geocoder||(this._geocoder=new google.maps.Geocoder);var e=this.getGoogleMapsPoint(),o={latLng:e};this._geocoder.geocode(o,dojo.hitch(this,"onAddressResult"))},findAddresses:function(){this._geocoder||(this._geocoder=new google.maps.Geocoder);var e=this.getGoogleMapsPoint(),o=new google.maps.LatLng(this._latitude+10,this._longitude+10),t=new google.maps.LatLngBounds(e,o),n={bounds:t};svzsolutions.global.mapManager.isDebugMode()&&console.log("GeocoderRequest [",n,"]"),this._geocoder.geocode(n,dojo.hitch(this,"onAddressesResult"))},getGoogleMapsPoint:function(){var e=new google.maps.LatLng(this.getLatitude(),this.getLongitude());return e},setGoogleMapsPoint:function(e){this.setLatitude(e.lat()),this.setLongitude(e.lng())},onAddressResult:function(){},onAddressesResult:function(){}})}),define("svzsolutions/generic/Loader",[],function(){dojo.declare("svzsolutions.generic.Loader",null,{LOADER_UNDERLAY_HOLDER_CLASS:"sg-loader-underlay-holder",LOADER_HOLDER_CLASS:"sg-loader-holder",LOADER_CANCEL_ELEM_CLASS:"sg-loader-cancel",DEFAULT_CANCEL_DELAY:3e3,constructor:function(e,o,t,n){n||(n={}),this._config=n,loaderUnderlayHolderClassName=this.LOADER_UNDERLAY_HOLDER_CLASS,loaderHolderClassName=this.LOADER_HOLDER_CLASS,this._cancelDelayHandler=null,e&&(loaderUnderlayHolderClassName+=" sg-"+e+"-underlay-holder",loaderHolderClassName+=" sg-"+e+"-holder"),this._underlayElem=dojo.create("div",{className:loaderUnderlayHolderClassName}),this._elem=dojo.create("div",{className:loaderHolderClassName}),o&&this.placeAt(o,t)},_onCancel:function(e){dojo.stopEvent(e),this.hide(),this.onCancel(e)},_showCancelElem:function(){if(this._cancelElem)dojo.style(this._cancelElem,"display","block");else{var e="Cancel";this._config.textCancel&&(e=this._config.textCancel),this._cancelElem=dojo.create("a",{className:this.LOADER_CANCEL_ELEM_CLASS,innerHTML:e,href:"#"},this._elem),this._cancelHandle=dojo.connect(this._cancelElem,"onclick",this,"_onCancel")}},onCancel:function(){},show:function(){dojo.style(this._elem,"display","block"),dojo.style(this._underlayElem,"display","block");var e=dojo.hitch(this,function(){this._showCancelElem()});this._cancelDelayHandler=this._config.showCancelDelay||this._config.showCancelDelay>=0?window.setTimeout(e,this._config.showCancelDelay):window.setTimeout(e,this.DEFAULT_CANCEL_DELAY)},hide:function(){this._cancelDelayHandler&&window.clearTimeout(this._cancelDelayHandler),this._cancelElem&&dojo.style(this._cancelElem,"display","none"),dojo.style(this._elem,"display","none"),dojo.style(this._underlayElem,"display","none")},placeAt:function(e,o){dojo.place(this._underlayElem,e,o),dojo.place(this._elem,e,o)},destroy:function(){return this._cancelDelayHandler&&window.clearTimeout(this._cancelDelayHandler),dojo.destroy(this._elem),dojo.destroy(this._underlayElem),this._cancelHandle&&dojo.disconnect(this._cancelHandle),!0}})}),define("svzsolutions/generic/Marker",["svzsolutions/generic/Geocode"],function(){dojo.declare("svzsolutions.generic.Marker",null,{constructor:function(e,o){this._config=e,this._map=o,this._shown=!1},_getConfig:function(e){if("googlemaps"==e){var o=new google.maps.LatLng(parseFloat(this._config.geoLat),parseFloat(this._config.geoLng)),t={};return t.content=this._config.content?this._config.content:"",t.map=this._map,t.position=o,t.title=this._config.title?this._config.title:"",t.draggable=this._config.draggable&&this._config.draggable===!0?!0:!1,t.dataLoadUrl=this._config.dataLoadUrl?this._config.dataLoadUrl:"",t.showInfoWindow=this._config.showInfoWindow&&this._config.showInfoWindow===!0?!0:!1,t}return!1},getConfig:function(e){return this._getConfig(e)},setMarkerType:function(e){this._config.markerType=e},getMarkerType:function(){return this._config.markerType},getMarkerTypeName:function(){return this._config.markerType.layerName},setPosition:function(e){this._config.geoLat=e.getLatitude(),this._config.geoLng=e.getLongitude();var o=new google.maps.LatLng(e.getLatitude(),e.getLongitude());this._overlay&&this._overlay.setPosition(o)},getPosition:function(){var e=this._overlay.getPosition(),o=new svzsolutions.generic.Geocode(e.lat(),e.lng());return o},getEntityId:function(){return this._config.entityId?this._config.entityId:""},setOverlay:function(e){this._overlay=e},getOverlay:function(){return this._overlay},isShown:function(){return this._shown},show:function(){!this.isShown()&&this._overlay&&this._overlay.setMap&&(this._overlay.setMap(this._map),this._shown=!0)},hide:function(){this._overlay&&this._overlay.setMap&&(this._overlay.setMap(null),this._shown=!1)},destroy:function(){this.hide()}})}),define("svzsolutions/generic/MarkerCache",[],function(){dojo.declare("svzsolutions.generic.MarkerCache",null,{constructor:function(){this._zoomLevel=[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21]},hasByZoomLevel:function(e){return this._zoomLevel[e]&&dojo.isObject(this._zoomLevel[e])?!0:!1},getByZoomLevel:function(e){return this._zoomLevel[e]},setByZoomLevel:function(e,o){svzsolutions.global.mapManager.isDebugMode()&&console.log("Setting on the zoom level [",e,"]"),this._zoomLevel[e]=o},hideAll:function(){console.log("MarkerCache: hiding all");for(var e=1;22>e;e++)this.hasByZoomLevel(e)&&e!=zoomLevel&&(console.log("Ok hiding for the markers on the zoom level [",e,"]"),this.getByZoomLevel(e).hideDynamicMarkersFromMap())},hideAllButZoomLevel:function(e){console.log("MarkerCache: hiding all but the provided zoom level [",e,"]");for(var o=1;22>o;o++)this.hasByZoomLevel(o)&&o!=e&&(console.log("Ok hiding for the markers on the zoom level [",o,"]"),this.getByZoomLevel(o).hideDynamicMarkersFromMap())},clear:function(){for(var e=1;22>e;e++)this.hasByZoomLevel(e)&&(this.getByZoomLevel(e).destroyDynamicMarkersFromMap(),this.getByZoomLevel(e).destroyFixedMarkersFromMap(),this.setByZoomLevel(e,null))}})}),define("svzsolutions/generic/MarkerCluster",["svzsolutions/generic/Marker"],function(){dojo.declare("svzsolutions.generic.MarkerCluster",svzsolutions.generic.Marker,{constructor:function(){},getConfig:function(e){var o=this._getConfig(e),t=new String(this._config.count);return o.className=this._config.markerType.className,o.className+=5>t.length?" sg-marker-cluster-size-"+t.length:" sg-marker-cluster-size-5",o.typeConfig=this._config.markerType,o.smartNavigation=this._config.smartNavigation,o.bounds=this._config.bounds,o.label=this._config.label,o.closestsMarkers=this._config.closestsMarkers,o}})}),define("svzsolutions/generic/MarkerList",["svzsolutions/generic/MarkerCluster"],function(){dojo.declare("svzsolutions.generic.MarkerList",svzsolutions.generic.MarkerCluster,{constructor:function(){},getConfig:function(e){var o=this._getConfig(e),t=new String(this._config.count);if(o.className=this._config.markerType.className,o.className+=5>t.length?" sg-marker-list-size-"+t.length:" sg-marker-list-size-5",o.typeConfig=this._config.markerType,o.label=this._config.label,o.entityIds=this._config.entityIds,o.closestsMarkers=this._config.closestsMarkers,this._config.dataLoadUrl+="?entityIds=",this._config.entityIds&&this._config.entityIds.length>0){for(var n=0;this._config.entityIds.length>n;n++)this._config.dataLoadUrl+=this._config.entityIds[n]+",";this._config.dataLoadUrl=this._config.dataLoadUrl.replace(/,$/,"")}return o.dataLoadUrl=this._config.dataLoadUrl,o}})}),define("svzsolutions/generic/MarkerManager",[],function(){dojo.declare("svzsolutions.generic.MarkerManager",null,{constructor:function(){this._staticLayers=[],this._fixedLayers=[],this._dynamicLayers=[]},add:function(e){if(e&&e._config.markerType&&e._config.markerType.layerName&&e._config.markerType.layerType){var o=e._config.markerType.layerName,t=e._config.markerType.layerType;switch(t){case"static":this._staticLayers[o]||(this._staticLayers[o]=[]),this._staticLayers[o].push(e);break;case"fixed":this._fixedLayers[o]||(this._fixedLayers[o]=[]),this._fixedLayers[o].push(e);break;case"dynamic":this._dynamicLayers[o]||(this._dynamicLayers[o]=[]),this._dynamicLayers[o].push(e)}}else console.error("MarkerManager: could not add marker to markerManager, no layerName or layerType provided.")},getAll:function(){var e=[];return e=this.getDynamic(),e=e.concat(this.getFixed()),e=e.concat(this.getStatic())},getByType:function(e){var o=[];return e?(o=this.getDynamicByType(e),o=dojo.mixin(this.getFixedByType(e))):o},getDynamic:function(){var e,o=[];for(var t in this._dynamicLayers){e=this._dynamicLayers[t];for(var n=0;e.length>n;n++){var i=e[n];o.push(i)}}return o},getDynamicByType:function(e){var o=[];if(!e)return o;var t;for(var n in this._dynamicLayers){t=this._dynamicLayers[n];for(var i=0;t.length>i;i++){var s=t[i];s.getMarkerTypeName()==e&&o.push(s)}}return o},getFixed:function(){var e,o=[];for(var t in this._fixedLayers){e=this._fixedLayers[t];for(var n=0;e.length>n;n++){var i=e[n];o.push(i)}}return o},getFixedByType:function(e){var o=[];if(!e)return o;var t;for(var n in this._fixedLayers){t=this._fixedLayers[n];for(var i=0;t.length>i;i++){var s=t[i];s.getMarkerTypeName()==e&&o.push(s)}}return o},getStatic:function(){var e,o=[];for(var t in this._staticLayers){e=this._staticLayers[t];for(var n=0;e.length>n;n++){var i=e[n];o.push(i)}}return o},getStaticByType:function(e){var o=[];if(!e)return o;var t;for(var n in this._staticLayers){t=this._staticLayers[n];for(var i=0;t.length>i;i++){var s=t[i];s.getMarkerTypeName()==e&&o.push(s)}}return o},hideDynamicMarkersFromMap:function(){svzsolutions.global.mapManager.isDebugMode()&&console.log("MarkerManager: hide dynamic markers from this map");var e;for(var o in this._dynamicLayers){e=this._dynamicLayers[o],svzsolutions.global.mapManager.isDebugMode()&&console.log("MarkerManager: current number of markers in layer [",o,"] is [",e.length,"]");for(var t=0;e.length>t;t++)e[t].hide()}},destroyDynamicMarkersFromMap:function(){var e;for(var o in this._dynamicLayers)for(e=this._dynamicLayers[o],svzsolutions.global.mapManager.isDebugMode()&&console.log("MarkerManager: current number of markers in layer [",o,"] is [",e.length,"]");marker=e.pop();)marker.destroy()},hideFixedMarkersFromMap:function(){var e;for(var o in this._fixedLayers){e=this._fixedLayers[o],svzsolutions.global.mapManager.isDebugMode()&&console.log("MarkerManager: current number of markers in layer [",o,"] is [",e.length,"]");for(var t=0;e.length>t;t++)e[t].hide()}},destroyFixedMarkersFromMap:function(){var e;for(var o in this._fixedLayers)for(e=this._fixedLayers[o],svzsolutions.global.mapManager.isDebugMode()&&console.log("MarkerManager: current number of markers in layer [",o,"] is [",e.length,"]");marker=e.pop();)marker.destroy()}})}),define("svzsolutions/generic/Math",[],function(){dojo.declare("svzsolutions.generic.Math",null,{MILES_TO_KILOMETRES_EQUATION:1.609344,constructor:function(){},roundNumber:function(e,o){(isNaN(o)||1>o)&&(o=0);var t=Math.pow(10,o),n=Math.round(e*t)/t;return n},metresToKilometres:function(e){var o=e/1e3;return o},metresToMiles:function(e){var o=this.metresToKilometres(e),t=this.kilometresToMiles(o);return t},kilometresToMiles:function(e){var o=e/this.MILES_TO_KILOMETRES_EQUATION;return o},milesToKilometres:function(e){var o=e*this.MILES_TO_KILOMETRES_EQUATION;return o}})}),define("svzsolutions/generic/RequestManager",[],function(){dojo.declare("svzsolutions.generic.RequestManager",null,{constructor:function(){this._requests=[]},get:function(e,o){return o&&e?(this.cancel(o),this._requests[o]=dojo.xhrGet(e)):void 0},cancel:function(e){e&&this._requests[e]&&this._requests[e].cancel()}})}),define("svzsolutions/maps/googlemaps/InfoWindow",["svzsolutions/generic/Loader"],function(){dojo.declare("svzsolutions.maps.googlemaps.InfoWindow",null,{COMPONENT_TAB_HOLDER_CLASSNAME:"sg-component-tabs-holder",COMPONENT_TAB_LINKS_HOLDER_CLASSNAME:"sg-component-tab-links-holder",COMPONENT_TAB_LINK_LOAD_DYNAMIC_CLASSNAME:"sg-component-tab-link-load-dynamic",COMPONENT_TAB_CONTENTS_HOLDER_CLASSNAME:"sg-component-tab-contents-holder",COMPONENT_TAB_CONTENT_HOLDER_CLASSNAME:"sg-component-tab-content-holder",COMPONENT_LIST_HOLDER_CLASSNAME:"sg-component-list-holder",COMPONENT_LIST_ITEM_HOLDER_CLASSNAME:"sg-component-list-item-holder",MAIN_HOLDER_CLASSNAME:"sg-info-window-content-main-holder",CONFIG_CLASSNAME:"sg-info-window-content-config",_tabContent:!1,_tabLinks:!1,constructor:function(e,o){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Constructor");var t=dojo.create("div");dojo.place(e,t),this._googleInfoWindowRef=o,this._tabLinks=!1,this._tabContent=!1,this._loader=!1,this._loaderTab=!1,this._mainHolder=!1,this._content=t,this._requestManager=new svzsolutions.generic.RequestManager,this._currentTabContent=!1,this._marker=!1,this._config=!1;var n=dojo.query("."+this.MAIN_HOLDER_CLASSNAME,this._content);n&&n[0]&&(this._mainHolder=n[0]);var i=dojo.query("."+this.CONFIG_CLASSNAME,this._content);i&&i[0]&&(this._config=dojo.fromJson(i[0].innerHTML)),this.init()},getConfig:function(){return this._config},getElem:function(){return this._content},init:function(){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Init");var e=dojo.query("."+this.COMPONENT_TAB_HOLDER_CLASSNAME,this._content);e&&e[0]&&this.initTabComponent(e[0]);var o=dojo.query("."+this.COMPONENT_LIST_HOLDER_CLASSNAME,this._content);o&&o[0]&&this.initListComponent(o[0]);var t=dojo.query("."+this.MAIN_HOLDER_CLASSNAME,this._content);t&&t[0]&&this.initCustomContent(t[0]),this.initLinks(this._content)},initTabComponent:function(e){this._tabLinks=dojo.query("."+this.COMPONENT_TAB_LINKS_HOLDER_CLASSNAME+" a",e),this._tabContent=dojo.query("."+this.COMPONENT_TAB_CONTENTS_HOLDER_CLASSNAME+" ."+this.COMPONENT_TAB_CONTENT_HOLDER_CLASSNAME,e);for(var o=0;this._tabLinks.length>o;o++)this._tabLinks[o].linkIndex=o,dojo.connect(this._tabLinks[o],"onclick",this,function(e){dojo.stopEvent(e),e.target&&this.activateTab(e.target.linkIndex)})},_findAElem:function(e){for(;"a"!=e.tagName.toLowerCase();)e=e.parentNode;return e},initLinks:function(e){this._links=dojo.query(".sg-load-data",e);for(var o=0;this._links.length>o;o++)dojo.connect(this._links[o],"onclick",this,function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Clicking link href"),dojo.stopEvent(e);var o=this._findAElem(e.target),t=dojo.attr(o,"href");svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Loading data url",t,o),this.loadData(t)})},initListComponent:function(e){this.listLinks=dojo.query("."+this.COMPONENT_LIST_ITEM_HOLDER_CLASSNAME+" a",e);for(var o=0;this.listLinks.length>o;o++)dojo.connect(this.listLinks[o],"onclick",this,function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Clicking link href"),dojo.stopEvent(e);var o=this._findAElem(e.target),t=dojo.attr(o,"href");svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: Loading data url",t,o),this.loadData(t)})},initCustomContent:function(){},initCustomTabContent:function(){},activateTab:function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: activating tab with index [",e,"]");for(var o="",t=!1,n=0;this._tabLinks.length>n;n++)dojo.removeClass(this._tabLinks[n],"active"),n==e&&(dojo.addClass(this._tabLinks[n],"active"),o=dojo.attr(this._tabLinks[n],"href"),dojo.hasClass(this._tabLinks[n],this.COMPONENT_TAB_LINK_LOAD_DYNAMIC_CLASSNAME)&&(t=!0));for(var n=0;this._tabContent.length>n;n++)dojo.removeClass(this._tabContent[n],"active"),n==e&&(dojo.addClass(this._tabContent[n],"active"),this._currentTabContent=this._tabContent[n]);t?this.loadTabData(o):this._requestManager.cancel("infoWindowLoadTabData")},loadData:function(e){if(!e)return!1;var o={url:e,handleAs:"json",load:dojo.hitch(this,this.loadDataCallback),error:dojo.hitch(this,function(e){this._loader.destroy(),this._loader=null,"cancel"!=e.dojoType&&svzsolutions.global.mapManager.isDebugMode()&&console.log("An unexpected error occurred: "+e)})};this._loader=new svzsolutions.generic.Loader("infowindow-load-data"),this._loader.onCancel=dojo.hitch(this,function(){this._requestManager.cancel("infoWindowLoadData")}),this._loader.placeAt(this._mainHolder,"first"),this._loader.show(),this._requestManager.get(o,"infoWindowLoadData")},loadDataCallback:function(e){if(this._mainHolder&&e&&e.content){var o=dojo._toDom(e.content);dojo.place(o,this._mainHolder,"only"),this.initTabComponent(o),this.initCustomContent(o),this.initLinks(o)}},loadTabData:function(e){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: load tab data from url [",e,"]"),!e)return!1;var o={url:e,handleAs:"json",load:dojo.hitch(this,this.loadTabDataCallback),error:dojo.hitch(this,function(e){this._loaderTab&&(this._loaderTab.destroy(),this._loaderTab=null),"cancel"!=e.dojoType&&console.log("An unexpected error occurred: "+e)})};this._loaderTab||(this._loaderTab=new svzsolutions.generic.Loader("infowindow-load-tab-data",this._currentTabContent,"first"),this._loaderTab.onCancel=dojo.hitch(this,function(){this._requestManager.cancel("infoWindowLoadTabData")})),this._loaderTab.show(),this._requestManager.get(o,"infoWindowLoadTabData")},loadTabDataCallback:function(e){if(this._currentTabContent&&e&&e.content){var o=dojo._toDom(e.content);dojo.place(o,this._currentTabContent,"only"),this.initCustomTabContent()}this._loaderTab.destroy(),this._loaderTab=null},setMarker:function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("InfoWindow: setting marker to [",e,"]"),this._marker=e},getMarker:function(){return this._marker},destroy:function(){this._googleInfoWindowRef&&this._googleInfoWindowRef.close()}})}),define("svzsolutions/maps/googlemaps/Address",[],function(){dojo.declare("svzsolutions.maps.googlemaps.Address",null,{constructor:function(e){this._address=e,this._geocoder=new google.maps.Geocoder},findGeocode:function(){var e={address:this._address};this._geocoder.geocode(e,dojo.hitch(this,"onGeocodeResult"))},onGeocodeResult:function(){}})}),define("svzsolutions/maps/googlemaps/CustomOverlay",[],function(){dojo.declare("svzsolutions.maps.googlemaps.CustomOverlay",null,{constructor:function(e){this._googleOverlay=new google.maps.OverlayView,this._googleOverlay.draw=this._draw,this._googleOverlay.remove=this._remove,this._googleOverlay.getPosition=this._getPosition,this._googleOverlay._config=e,this._config=e,this._googleOverlay.latlng_=e.position,this._googleOverlay.getDom=this.getDom,google.maps.event.addListener(this._googleOverlay,"click",dojo.hitch(this,"onClick")),google.maps.event.addListener(this._googleOverlay,"mouseover",dojo.hitch(this,"onMouseOver"))},setMap:function(e){this._googleOverlay.setMap(e)},onClick:function(){},onMouseOver:function(){},_draw:function(){var e=this.div_;if(!e){e=this.div_=dojo.create("div",{className:this._config.className,title:this._config.title}),this._config.label&&"undefined"!=this._config.label&&dojo.create("div",{className:"sg-label",innerHTML:this._config.label},e),google.maps.event.addDomListener(e,"click",dojo.hitch(this,function(){google.maps.event.trigger(this,"click")})),google.maps.event.addDomListener(e,"mouseover",dojo.hitch(this,function(){google.maps.event.trigger(this,"mouseover")}));var o=this.getPanes();o.overlayImage.appendChild(e)}var t=this.getProjection().fromLatLngToDivPixel(this.getPosition()),n={};if(t){var i=0,s=0,a=this._config.typeConfig.iconSize?this._config.typeConfig.iconSize.width:!1,r=this._config.typeConfig.iconSize?this._config.typeConfig.iconSize.height:!1;(this._config.typeConfig.autoCenter||this._config.typeConfig.autoCenterY||this._config.typeConfig.autoCenterX)&&(a===!1&&(a=e.clientWidth),r===!1&&(r=e.clientHeight)),this._config.typeConfig.autoCenter?(i=a/2,s=r/2):this._config.typeConfig.autoCenterY?(i=a,s=r/2):this._config.typeConfig.autoCenterX?(i=a/2,s=r):(i=this._config.typeConfig.correctionX,s=this._config.typeConfig.correctionY),n.left=t.x-i+"px",n.top=t.y-s+"px"}return n.position="absolute",dojo.style(e,n),e},remove:function(){this._googleOverlay.div_&&dojo.destroy(this._googleOverlay.div_)},_remove:function(){this.div_&&dojo.destroy(this.div_)},setPosition:function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("CustomOverlay: Setting a new position"),this._googleOverlay.setPosition(e)},getPosition:function(){return this._googleOverlay.getPosition()},_getPosition:function(){return this.latlng_}})}),define("svzsolutions/maps/googlemaps/Map",["svzsolutions/generic/Debug","svzsolutions/generic/Geocode","svzsolutions/generic/Loader","svzsolutions/generic/Marker","svzsolutions/generic/MarkerCache","svzsolutions/generic/MarkerCluster","svzsolutions/generic/MarkerList","svzsolutions/generic/MarkerManager","svzsolutions/generic/Math","svzsolutions/generic/RequestManager","svzsolutions/maps/googlemaps/InfoWindow","svzsolutions/maps/googlemaps/Address","svzsolutions/maps/googlemaps/CustomOverlay"],function(){dojo.declare("svzsolutions.maps.googlemaps.Map",null,{INFO_WINDOW_CONTENT_CLASS:"info-window-content",constructor:function(e){this._config=e,this._map=null,this._markerCache=new svzsolutions.generic.MarkerCache,this._markerManager=new svzsolutions.generic.MarkerManager,this._markerManagerStatic=new svzsolutions.generic.MarkerManager,this._requestManager=new svzsolutions.generic.RequestManager,this._loadDataForm=null,this._loader=null,this._loaderInfoWindow=null,this._loaded=!1,this._eventHandlesGoogle=[],this._cachingEnabled=!1},setLoadDataOnce:function(e){this._config.loadDataOnce=e?!0:!1,this._dataLoaded=!1},setDataLoadUrl:function(e){this._dataLoaded=!1,this._config.dataLoadUrl=e},getConfig:function(){return this._config},load:function(){this._infoWindow=new google.maps.InfoWindow;var e={},o={};e.center=new google.maps.LatLng(this._config.centerGeoLat,this._config.centerGeoLng),e.zoom=this._config.zoomLevel,e.mapTypeId=this._config.mapType,this._config.caching&&(this._cachingEnabled=!0);var t=this._config.controls;t.mapType?(e.mapTypeControl=!0,o={},o.mapTypeIds=t.mapType.mapTypeIds,o.position=dojo.getObject(t.mapType.position),o.style=dojo.getObject(t.mapType.style),e.mapTypeControlOptions=o):e.mapTypeControl=!1,t.streetView?(e.streetViewControl=!0,o={},o.position=""==t.streetView.position?"":dojo.getObject(t.streetView.position),e.streetViewControlOptions=o):e.streetViewControl=!1,t.scale?(e.scaleControl=!0,o={},o.position=dojo.getObject(t.scale.position),o.style=dojo.getObject(t.scale.style),e.scaleControlOptions=o):e.scaleControl=!1,t.pan?(o={},o.position=dojo.getObject(t.pan.position),e.panControlOptions=o):e.panControl=!1,t.zoom?(o={},o.position=dojo.getObject(t.zoom.position),o.style=dojo.getObject(t.zoom.style),e.zoomControlOptions=o):e.zoomControl=!1,svzsolutions.global.mapManager.isDebugMode()&&console.log("Generated the following Google Maps config [",e,"]");var n;if(this._config.mapContainer?n=this._config.mapContainer:this._config.mapContainerId&&(n=dojo.byId(this._config.mapContainerId)),this._map=new google.maps.Map(n,e),this._config.layers)for(var i=0;this._config.layers.length>i;i++){var s=new google.maps.Layer(this._config.layers[i]);this.getMap().addOverlay(s)}if(this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"idle",dojo.hitch(this,this._onIdle))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"zoom_changed",dojo.hitch(this,this._onZoomLevelChanged))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"drag",dojo.hitch(this,this._onDrag))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"dragend",dojo.hitch(this,this._onDragend))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"center_changed",dojo.hitch(this,this._onCenterChanged))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"dblclick",dojo.hitch(this,this._onMouseDoubleClick))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"rightclick",dojo.hitch(this,this._onMouseRightClick))),this._eventHandlesGoogle.push(google.maps.event.addListener(this.getMap(),"maptypeid_changed",dojo.hitch(this,this._onMapTypeChanged))),this._config.markers){var a={};a.markers=this._config.markers,this._processMarkers(a.markers)}this._loaded=!0,this.onMapLoaded()},setCenter:function(e){if(!e)return!1;var o=new google.maps.LatLng(e.getLatitude(),e.getLongitude());this.getMap().panTo(o)},getCenter:function(){var e=this.getMap().getCenter(),o=new svzsolutions.generic.Geocode(e.lat(),e.lng());return o},isLoaded:function(){return this._loaded},getMap:function(){return this._map},getId:function(){return this._config.mapId},getMapContainer:function(){return this.getMap().getDiv()},getMapContainerId:function(){return this._config.mapContainerId},_onIdle:function(e){this.loadData(),this.onIdle(e)},_onZoomLevelChanged:function(e){this._infoWindow.close(),this.onZoomLevelChanged(e)},_onDrag:function(){this.onDrag()},_onDragend:function(){this.onDragend()},_onMarkerDragEnd:function(){this.instance.onMarkerDragEnd(this.marker2)},_onMarkerMouseOver:function(){this.onMarkerMouseOver(this._currentMarker)},_onMarkerClick:function(){this.onMarkerClick(this._currentMarker)},_loadInfoWindow:function(){var e=this._infoWindow.dataLoadUrl;if(e){var o={url:e,handleAs:"json",load:dojo.hitch(this,"_loadInfoWindowCallback"),error:dojo.hitch(this,function(e){if(this._loaderInfoWindow&&(this._loaderInfoWindow.destroy(),this._loaderInfoWindow=null),"cancel"!=e.dojoType){var o=dojo.create("div",{className:"sg-message-holder sg-error"}),t=dojo.create("p",{},o);t.innerHTML="An error occured trying to load the content, please try again.",this._infoWindow.setContent(o),console.error("MarkerClick: An unexpected error occurred: ",e)}})};this._requestManager.get(o,"loadInfoWindowData")}},_loadInfoWindowCallback:function(e){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: InfoWindowCallback"),this._loaderInfoWindow&&(this._loaderInfoWindow.destroy(),this._loaderInfoWindow=null),e&&"object"==typeof e&&e.content){var o=dojo._toDom(e.content);this._infoWindow.setContent(o);var t=dojo.hitch(this,function(){var e=new svzsolutions.maps.googlemaps.InfoWindow(this._infoWindow.getContent(),this._infoWindow);e.setMarker(this._infoWindow._marker),this.onInfoWindowContentLoaded(e),dojo.connect(e,"initCustomTabContent",this,function(){this.onInfoWindowTabContentLoaded(e)}),this._infoWindow.open(this.getMap(),this._currentMarker)});setTimeout(t,1)}},isMarkerInViewPort:function(e){if(e){var o=e.getPosition().getGoogleMapsPoint(),t=this.getMap().getBounds();return t.contains(o)}return!1},getZoomLevel:function(){return this.getMap().getZoom()},setZoomLevel:function(e){this.getMap().setZoom(e)},getViewPortInfo:function(){var e=this.getMap().getBounds(),o=e.getSouthWest(),t=e.getNorthEast(),n=this.getMap().getZoom(),i=this.getMap().getCenter(),s={zoom:n,sw_lat:o.lat(),sw_lng:o.lng(),ne_lat:t.lat(),ne_lng:t.lng(),ce_lat:i.lat(),ce_lng:i.lng(),w:this.getConfig().width,h:this.getConfig().height};return s},setLoadDataForm:function(e){this._loadDataForm=e},reloadData:function(){this._cachingEnabled&&this._markerCache.clear(),this.loadData()},loadData:function(){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: loading data, with option loadDataOnce [",this._config.loadDataOnce,"] / dataLoaded [",this._dataLoaded,"] and dataLoadUrl [",this._config.dataLoadUrl,"]"),!this._config.loadDataOnce||!this._dataLoaded){var e=this.getViewPortInfo();if(this._config.dataLoadUrl)if(this._cachingEnabled&&this._markerCache.hasByZoomLevel(e.zoom)){this._markerCache.hideAllButZoomLevel(e.zoom);var o=this._markerCache.getByZoomLevel(e.zoom);svzsolutions.global.mapManager.isDebugMode()&&console.log("Showing markers from cache"),this._showMarkers(o)}else{var t={url:this._config.dataLoadUrl,failOk:!0,content:e,form:this._loadDataForm,handleAs:"json",load:dojo.hitch(this,this._loadDataCallback),error:function(e){this._loader.hide(),"cancel"!=e.dojoType&&console.log("An unexpected error occurred: "+e)}};if(!this._loader){var n=this.getMap().getDiv().childNodes[0];this._loader=new svzsolutions.generic.Loader("load-data",n,"first"),this._loader.onCancel=dojo.hitch(this,function(){this._requestManager.cancel("loadData"+this._config.mapIndex)})}this._loader.show(),this._requestManager.get(t,"loadData"+this._config.mapIndex)}}},_processMarkers:function(e){for(var o,t,n,i=e.length,s=new svzsolutions.generic.MarkerManager,a=0;i>a;a++)if(o=e[a],this._config.markerTypes[o.type])try{t=this._config.markerTypes[o.type],o.markerType=t,n=null,n="cluster"==o.type?new svzsolutions.generic.MarkerCluster(o,this.getMap()):"list"==o.type?new svzsolutions.generic.MarkerList(o,this.getMap()):new svzsolutions.generic.Marker(o,this.getMap()),"static"==t.layerType||"fixed"==t.layerType?this._markerManagerStatic.add(n):s.add(n)}catch(r){console.error("Map: loading marker failed [",r,"]")}else console.error('Map: The marker type called "'+o.type+'" seems to be not registered.');this._cachingEnabled?!this._markerCache.hasByZoomLevel(this.getZoomLevel())&&s.getDynamic().length>0&&this._markerCache.setByZoomLevel(this.getZoomLevel(),s):this._markerManager=s,this._showMarkers(s),this._showMarkers(this._markerManagerStatic),this.onMarkersShown()},_showMarkers:function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: gonna show all the markers now");var o,t,n,i,s,a=e.getAll(),r=a.length,l=0;
for(l;r>l;l++)o=a[l],o.isShown()||(n=o.getConfig("googlemaps"),i=o.getMarkerType(),s=o._config,"cluster"==o._config.type?t=new svzsolutions.maps.googlemaps.CustomOverlay(n):"list"==o._config.type?t=new svzsolutions.maps.googlemaps.CustomOverlay(n):i.iconEnabled?(i.icon&&(n.icon=new google.maps.MarkerImage(i.icon.url,new google.maps.Size(i.icon.size.width,i.icon.size.height))),i.shadow&&(n.shadow=new google.maps.MarkerImage(i.shadow.url,new google.maps.Size(i.shadow.size.width,i.shadow.size.height))),t=new google.maps.Marker(n)):(n.className=i.className,n.typeConfig=i,n.label=s.label,t=new svzsolutions.maps.googlemaps.CustomOverlay(n)),t.type=i,t.typeName=s.type,s.entityId&&(t.entityId=s.entityId),s.draggable&&(markerThis={},markerThis.instance=this,markerThis.marker=t,markerThis.marker2=o,google.maps.event.addListener(t,"dragend",dojo.hitch(markerThis,this._onMarkerDragEnd))),o.setOverlay(t),this._bindMarker(t,n.content,n.dataLoadUrl,o),o.show())},_loadDataCallback:function(e){return svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: load DataCallback fired with data [",e,"]"),this._loader&&this._loader.hide(),this._cachingEnabled?this._markerCache.hideAllButZoomLevel(this.getZoomLevel()):this._markerManager.hideDynamicMarkersFromMap(),this._config.markerTypes?(this._dataLoaded=!0,e&&"object"==typeof e&&e.markers&&this._processMarkers(e.markers),svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: finished processing of returned data."),void 0):(console.error("No marker types seems to be registered."),void 0)},_bindMarker:function(e,o,t,n){if("zoom"==e.type.clickAction){var i=function(){var o=0;o=e._config.smartNavigation&&e._config.smartNavigation.zoomToLevel?e._config.smartNavigation.zoomToLevel:this.getMap().getZoom()+1,this.getMap().setCenter(e._config.position),this.getMap().setZoom(o)};e.declaredClass&&"svzsolutions.maps.googlemaps.CustomOverlay"==e.declaredClass?dojo.connect(e,"onClick",dojo.hitch(this,i)):google.maps.event.addListener(e,"click",dojo.hitch(this,i))}else{var s=function(){if(t){var i=dojo.create("div",{className:this.INFO_WINDOW_CONTENT_CLASS});this._infoWindow.setContent(i),this._infoWindow._marker=n,this._loaderInfoWindow||(this._loaderInfoWindow=new svzsolutions.generic.Loader("load-info-window-data",i,"first"),this._loaderInfoWindow.onCancel=dojo.hitch(this,function(){this._requestManager.cancel("loadInfoWindowData"),this._infoWindow.close()})),this._infoWindow.dataLoadUrl=t,e._googleOverlay?(this._currentMarker=e._googleOverlay,this._infoWindow.open(this.getMap(),e._googleOverlay)):(this._currentMarker=e,this._infoWindow.open(this.getMap(),e))}else if(o){"string"==typeof o&&(o=dojo._toDom(o)),this._infoWindow.setContent(o);var s=new svzsolutions.maps.googlemaps.InfoWindow(this._infoWindow.getContent());s.setMarker(n),this._infoWindow.open(this.getMap(),e),this.onInfoWindowContentLoaded(this._infoWindow)}};e.declaredClass&&"svzsolutions.maps.googlemaps.CustomOverlay"==e.declaredClass?(dojo.connect(e,"onClick",dojo.hitch(this,s)),dojo.connect(e,"onClick",this,"_onMarkerClick"),dojo.connect(e,"onMouseOver",this,"_onMarkerMouseOver"),t&&(dojo.connect(e,"onClick",this,"_loadInfoWindow"),e.type.enableDataLoadOnMouseOver&&(dojo.connect(e,"onMouseOver",dojo.hitch(this,s)),dojo.connect(e,"onMouseOver",this,"_loadInfoWindow")))):(google.maps.event.addListener(e,"click",dojo.hitch(this,s)),google.maps.event.addListener(e,"click",dojo.hitch(this,"_onMarkerClick")),google.maps.event.addListener(e,"mouseover",dojo.hitch(this,"_onMarkerMouseOver")),t&&(google.maps.event.addListener(e,"click",dojo.hitch(this,"_loadInfoWindow")),e.type.enableDataLoadOnMouseOver&&(google.maps.event.addListener(e,"mouseover",dojo.hitch(this,s)),google.maps.event.addListener(e,"mouseover",dojo.hitch(this,"_loadInfoWindow"))))),e.showInfoWindow&&dojo.hitch(this,s)()}},addMarker:function(e,o){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: Adding marker [",e,"] with type [",o,"]"),e){if(!o)return console.error("Map: add marker, no marker type specified."),!1;if(!this._config.markerTypes[o])return console.error("Map: add marker, invalid marker type specified."),!1;e.setMarkerType(this._config.markerTypes[o]),this.getMarkers().add(e),this._showMarkers(this.getMarkers())}},getMarkers:function(){var e=this.getZoomLevel();return this._cachingEnabled&&this._markerCache.hasByZoomLevel(e)?this._markerCache.getByZoomLevel(e):this._markerManager},getMarkersStatic:function(){return this._markerManagerStatic},resize:function(e){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("Map: firing resize "),google.maps.event.trigger(this.getMap(),"resize"),!e){var o=new google.maps.LatLng(this._config.centerGeoLat,this._config.centerGeoLng);this.getMap().setCenter(o)}},_onMapTypeChanged:function(){this.onMapTypeChanged()},_onCenterChanged:function(){this.onCenterChanged()},_onMouseRightClick:function(){this.onMouseRightClick()},_onMouseDoubleClick:function(){this.onMouseDoubleClick()},onIdle:function(){},onZoomLevelChanged:function(){},onDrag:function(){},onDragend:function(){},onMarkerDragEnd:function(){},onMarkerMouseOver:function(){},onMarkerClick:function(){},onInfoWindowContentLoaded:function(){},onInfoWindowTabContentLoaded:function(){},onMapLoaded:function(){},onMarkersShown:function(){},onMapTypeChanged:function(){},onCenterChanged:function(){},onMouseRightClick:function(){},onMouseDoubleClick:function(){},destroy:function(){this._requestManager.cancel("loadData"+this._config.mapIndex),this._markerManager.destroyDynamicMarkersFromMap(),this._markerManager.destroyFixedMarkersFromMap();for(var e=0;this._eventHandlesGoogle.length>e;e++)this._eventHandlesGoogle[e].remove();this.getMap().getDiv()&&dojo.destroy(this.getMap().getDiv())}})}),define("svzsolutions/maps/MapManager",["svzsolutions/maps/googlemaps/Map"],function(){dojo.declare("svzsolutions.maps.MapManager",null,{constructor:function(e){this._debugMode=e&&e.debugMode===!0?!0:!1,this._maps=[],this._googleMapsLibraryLoaded=!1,this._googleMapsLibraryRequested=!1,this._googleMapsConfigs=[],this._mapIndex=-1,svzsolutions.global&&svzsolutions.global.mapManager&&"undefined"!=typeof google&&google.maps!==void 0&&(this._googleMapsLibraryLoaded=!0),svzsolutions.global||(svzsolutions.global={}),svzsolutions.global.mapManager=this,dojo.addOnWindowUnload(dojo.hitch(this,this.destroy))},isDebugMode:function(){return this._debugMode},getByIndex:function(e){return 0>e?(console.error("MapManager getByIndex: No map index provided."),!1):this._maps[e]?this._maps[e]:(console.error("MapManager getByIndex: Could not find a map with index: [",e,"]"),!1)},initByConfig:function(e){if(!e)return!1;if(dojo.isObject(e)||(e=dojo.fromJson(e)),svzsolutions.global.mapManager.isDebugMode()&&console.log("MapManager: Adding and initializing config: ",e),e.libraryConfig)switch(e.libraryConfig.name){case"googlemaps":this._mapIndex++;var o=new svzsolutions.maps.googlemaps.Map(e);return o.index=this._mapIndex,this._maps[this._mapIndex]=o,this._maps[this._mapIndex]}return!1},destroyByIndex:function(e){svzsolutions.global.mapManager.isDebugMode()&&console.log("MapManager: Trying to destroy the map by mapIndex",e);var o=this.getByIndex(e);o.destroy()},startup:function(){for(var e=0;this._maps.length>e;e++){var o=null;if((o=this._maps[e].getConfig())&&o.libraryConfig)switch(o.libraryConfig.name){case"googlemaps":this._loadGoogleMapsLibrary(o)}}},_loadGoogleMapsLibrary:function(e){this._googleMapsLibraryLoaded?this._loadGoogleBasedMaps(e):this._loadGoogleMaps(e)},_loadGoogleMaps:function(e){if(this._googleMapsConfigs.push(e),!this._googleMapsLibraryRequested){this._googleMapsLibraryRequested=!0;var o=document.createElement("script");o.src="http://maps.google.com/maps/api/js?sensor=false&callback=svzsolutions.global.mapManager._loadGoogleMapsCallback",o.type="text/javascript",document.getElementsByTagName("head")[0].appendChild(o)}},_loadGoogleMapsCallback:function(){this._googleMapsLibraryLoaded=!0,this._loadGoogleBasedMaps()},_loadGoogleBasedMaps:function(){if(svzsolutions.global.mapManager.isDebugMode()&&console.log("MapManager: Load google based maps"),this._maps)for(var e=0;this._maps.length>e;e++)this._maps[e].isLoaded()||(svzsolutions.global.mapManager.isDebugMode()&&console.log("MapManager: Map is not loaded yet"),this._maps[e].load())},destroy:function(){if(this._maps)for(var e=0;this._maps.length>e;e++)this._maps[e].destroy();this._maps=null,this._googleMapsConfigs=null,this._maps=[],this._googleMapsConfigs=[],this._mapIndex=-1}})}),require(["svzsolutions/maps/MapManager"]),define("../all",[],function(){});